%!octave 
%
%
%
%       OS : GNU/Linux 4.2.5
% COMPILER : GNU Octave, version 4.0.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: rnn_fit.m,v 1.6 2017/03/20 09:41:23 mechanoid Exp $


% - - - - - - - - - - - - - - - - 
function [W,er_hist] = rnn_fit(W,X,y,Xc,yc),
   [W,er_hist] = rnn_fit_gradient_descent(W,X,y,Xc,yc);
endfunction

% - - - - - - - - - - - - - - - - 
% метод простого градиентного спуска
function [W,er_hist] = rnn_fit_gradient_descent(W,X,y,Xc,yc),
   a = 0.05 ; % скорость обучения
   er_max = 0.07 ; % порог допустимой ошибки
   n = 4e3 ; % максимальное количество эпох обучения
  
   er_hist = [] ; % история изменения ошибки	 
   for j = 1:n,
      l = rnn_loss(Xc,W,yc) ;
      er_hist = [ er_hist , l ] ;
      printf("[i] эпоха %i/%i, ошибка обучения: %f/%f     \r",j,n, l,er_max) ;
      if l < er_max, break; endif
      dW = rnn_gradient(X,W,y) ; % вычисляем значения градиента 
      dW = rnn_weight_norm(dW) ; % нормируем градиент
      W = rnn_weight_correct(W,dW,a) ; % изменяем веса
   endfor 
   printf("\n");

endfunction

% - - - - - - - - - - - - - - - - 
function retval = rnn_weight_correct(W,dW,a),
   
   W{1}{1} -= a * dW{1}{1} ;
   W{1}{2} -= a * dW{1}{2} ;
   W{1}{3} -= a * dW{1}{3} ;
   W{2}{1} -= a * dW{2}{1} ;
   W{2}{2} -= a * dW{2}{2} ;

   retval = W ;
endfunction

