%!octave 
%
%
%
%       OS : GNU/Linux 4.2.5
% COMPILER : GNU Octave, version 4.0.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: rnn_forward.m,v 1.4 2017/02/26 18:24:20 mechanoid Exp $


% - - - - - - - - - - - - - - - - 
function retval = rnn_forward(X,W),

   hs = [ size(W{1}{2},1) ,1 ] ; % размер скрытого слоя
   h = zeros(hs) ; % начальное значение выходов скрытого слоя 
   
   n = size(X,1) ; % размер одного элемента последовательности
   m = size(X,2) ; % длинна последовательности
   k = size(X,3) ; % количество примеров


   for t = 1:m,
      Xt = reshape( X(:,t,:) , [n,k] ) ; % элементы последовательностей номер t для всех примеров 
      h = rnn_activate( W{1}{1}*Xt + W{1}{2}*h + W{1}{3} ) ;
   endfor

   retval = softmax( W{2}{1} * h + W{2}{2} ) ;

endfunction

