%!octave 
%
%
%
%       OS : GNU/Linux 4.2.5
% COMPILER : GNU Octave, version 4.0.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: rnn_loss.m,v 1.2 2017/02/24 10:06:03 mechanoid Exp $

% - - - - - - - - - - - - - - - - 
function retval = rnn_loss(X,W,y),
   o = rnn_forward(X,W) ;
   retval = cross_entr(o,y) ;
endfunction

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% функция потери - средняя кросс-энтропия
function retval = cross_entr(o,y),
   %[v,n]=max(y); % извлекаем номер класса из выходного вектора

   num_examples = length(y) ; % количество учебных примеров

   % вероятность p(i) принадлежности входа X(i) к к своему классу y(i) 
   p=[];
   for i=1:num_examples, 
      p(i) = o( y(i), i ) ; 
   endfor
   
   data_loss = sum(-log(p))/num_examples ; % средняя кросс-энтропия по всем учебным примерам
   
   retval = data_loss ;

endfunction

